
/* 
 * File:   demoConst.c
 * Author: Nathan
 *
 * Created on 13. Dezember 2015, 20:25
 */
#define _SUPPRESS_PLIB_WARNING
#define _DISABLE_OPENADC10_CONFIGPORT_WARNING

#include <xc.h>			   // Required for SFR defs
#include <sys/attribs.h>   // Required to use __longramfunc__
						   // and __ramfunc__ macros.
#include  "CFunctions.h"

//
// make some address calculations to get the flash position of the actual
// function. This should be possilbe by fp pointer, too.
// I do not trust the fp, lets use the ra register instead
// (a) is point to function, (b) pointer to label, (c) pointer for result
// if a is set to NULL the offset will be output, usefull fo static const calculation.
//

 __attribute__((noinline)) void getFPC(void *a, void *b, volatile unsigned int *c)
     {
         *c = (unsigned int) (__builtin_return_address (0) - (b -a)) ;     
     }
 

 void main(long long *_iii, long long *_ii, long long *_ax) {

 //keep the following lines together, lableAdr will contains adress of main
 //if used within an other function, please adapt main -> function name
 volatile unsigned int libAddr ;
 getFPC(&main,&&getFPCLab,&libAddr) ; // warning can be ignored, stupid editor
 getFPCLab: { }
 //
 
 unsigned int offs = libAddr - (unsigned int)&main ;
 // hi basic this is my flash address (loadable graphic functions= 
 _ax[0] = libAddr ;
 //static const unsigned char asd[] __attribute__((section (".constdata,r"))) = "Dies ist ein Test." ;
 // --> static const is required
 static const unsigned char asd1[] = "Hi, " ;
 static const unsigned char asd2[] = "if you can" ;
 static const unsigned char asd3[] = "read this" ;
 static const unsigned char asd4[] = "then you" ;
 static const unsigned char asd5[] = "got it running." ;
 static const unsigned char asd6[] = "---------------" ;
 static const unsigned char asd7[] = "7" ;
 static const unsigned char asd8[] = "8" ;
 static const unsigned char asd9[] = "9 " ;
 static const unsigned char asd10[] = "(default)" ;
 
 unsigned char  *_string = (unsigned char *)_ii;
 unsigned int i = 0 ;
 unsigned int iii = *_iii ;
 unsigned char * xptr ;
 //
 // simple switch example (this is a stupid examplr)
 //
 switch ( iii ) {
    case 1:
           xptr = (unsigned char *)asd1 ;
           break ;
    case 2:
           xptr = (unsigned char *)asd2 ;
           break ;
    case 3:
           xptr = (unsigned char *)asd3 ;
           break ;
    case 4:
           xptr = (unsigned char *)asd4 ;
           break ;
    case 5:
           xptr = (unsigned char *)asd5 ;
           break ;
    case 6:
           xptr = (unsigned char *)asd6 ;
           break ;
    case 7:
           xptr = (unsigned char *)asd7 ;
           break ;
    case 8:
           xptr = (unsigned char *)asd8 ;
           break ;
    case 9:
           xptr = (unsigned char *)asd9 ;
           break ;
    default:
           xptr = (unsigned char *)asd10 ;
 }
 //
 // the next is required for every access of a const declaration
 // add the offset ( to adapt the different locations between cfunction in flash#
 //                  and locations during compilation/linking), manual gop
 // --> you need an address, which you can manipultate <--
 //
 xptr += offs ;
 
 //
 // lets access the const data string, and copy it to the basic-ram 
 //
 for(i=1; *xptr && i != 256 ;i++){
   _string[i]= (unsigned char)*xptr;
   xptr++ ;
 }
 _string[0]= i-1 ;
}
 
// How to use ...
// please use the following settings:
//
// xc32-gcc properties
// have symbols     : x
// exclude float lib: x
// add options      : -fPIC -mno-abicalls -shared -membedded-data -mno-long-calls -fno-jump-tables -mno-jals  -mgpopt -Wuninitialized -Wunused-variable -Wunused-value -Wunreachable-code
// optimization     : 1
//
// x32-ld properties
// libraries
// exclude standard libs: x
// do not link startup code: x
// exclude floating point lib: x
//
// the static const var data will be stored within the .rodata section in elf file
// this data has to be add to the end of the cfunctions data. Address gaps has to be closed by nop
// entries. 
// Cfuncgen and cfgen has to be modified to output .rodata following a)-c).
// a) section order 
// .text:   output
// .rodata: output unmodified
// .dinit (contense of .dinit can be ignored)
// b) section order  
// .dinit (contense of .dinit can be ignored)
// .text:    output
// .rodata:  output unmodified
// c) section order <------- take care critical
// .text:    output
// .dinit    output unmodified
// .rodata   output unmodified
// for the moment you hav to add manually the output
//
// switch seems to work up to 6 entries + default, not clear what happens behind the limit
//